﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.5
@EndOfDesignText@
#ignorewarnings:12
#Region BANano 
	' <-------------- IMPORTANT! This is because we want this module to be transpiled by BANano 
#End Region

'Static code module
Sub Class_Globals	
	Public vuetify As VuetifyApp
	Public page As VueComponent
	Public path As String
	Public name As String = "fe2"
	Private banano As BANano	'ignore
	Private btnShowDialog As VBtn
	Private VCol1 As VCol
	Private VContainer1 As VContainer
	Private VFlexDialog1 As VFlexDialog
	Private VFlexDialog1Form As VForm
	Private VRow1 As VRow
	Private prjcomplete As VField
	Private prjcomplete1 As VField
	Private chipQuantity As VField
	Private chpX As VField
	Private chpavatar As VField
	Private btnIcon As VField
	Private btnUpload As VField
	Private btnIcon2 As VField
	Private btnIcon3 As VField
	'
	Private btnImage1 As VField
	Private btnImage2 As VField
	Private icnWifi As VField
	Private icnWifi1 As VField
	Private ano As VField
	Private ano1 As VField
End Sub

Sub Initialize(v As VuetifyApp)
	'establish a reference to the app
	vuetify = v
	'initialize the component
	page.Initialize(Me, name)
	page.vuetify = vuetify
	'set the page title
	page.Title = "Page"
	'uncomment this line if this will be the first page
	'page.StartPage
	path = page.path
	'
	'build the page html here
	banano.LoadLayout(page.Here, "fe2layout")
	VFlexDialog1Form = VFlexDialog1.Form
	BuildForm
	
	'initialize this on pgIndex.AddPages
	'add the route page to vuetify instance
	vuetify.AddRoute(page)
End Sub

Private Sub quantity_Plus (e As BANanoEvent)
	chipQuantity.IncrementChip(page)
End Sub

Private Sub quantity_Minus (e As BANanoEvent)
	chipQuantity.DecrementChip(page)
End Sub


Sub BuildForm
	VFlexDialog1.Clear
	'
	VFlexDialog1.AddProgressCircular(1, 1, "prjcomplete", "100", "5", 45)
	VFlexDialog1.AddProgressLinear(1, 2, "prjcomplete1", "15px", 45)
	VFlexDialog1.SetItemColors("prjcomplete1", "black", "normal", "white", "normal")
	VFlexDialog1.SetItemColors("prjcomplete", "blue", "normal", "blue", "normal")
	'
	VFlexDialog1.AddMinusPlus(2, 1, "quantity", "10", "", False)
	VFlexDialog1.AddChip(2, 2, "quantityx", "Chip X", "", True)
	VFlexDialog1.SetItemColors("quantityx", "blue", "normal", "white", "normal")
	'VFlexDialog1.AddChipAvatar(2, 3, "chpavatar", "./assets/myself.jpg", "Mashy", "", False)
	VFlexDialog1.SetItemColors("quantity", "green", "normal", "white", "normal")
	'
	VFlexDialog1.AddButtonIcon(3, 1, "btnIcon1", "mdi-vuetify", True, False).SetItemSize("btnIcon1", vuetify.SIZE_XLARGE)
	VFlexDialog1.AddFileInputButton(3, 2, "upload", "Upload")
	'
	VFlexDialog1.AddButtonTextIcon(4, 1, "btnIcon2", "Left Icon", "mdi-stadium-outline", "left", True, False, False, False)
	VFlexDialog1.AddButtonTextIcon(4, 2, "btnIcon3", "Right Icon", "mdi-file-tree", "right", True, False, False, False)
	'
	VFlexDialog1.AddButtonTextImage(5, 1, "btnImage1", "Left Image", "./assets/img5.png", "left", "circle",  True, False, True, False)
	VFlexDialog1.AddButtonTextImage(5, 2, "btnImage2", "Right Image", "./assets/img8.png", "right", "rounded", True, False, False, False)
	'
	VFlexDialog1.AddIcon(6, 1, "wifi", "mdi-plane-car", vuetify.SIZE_LARGE, "", True).SetItemColors("wifi", "orange", vuetify.INTENSITY_DARKEN1, "", "")
	VFlexDialog1.AddIcon(6, 2, "wifi1", "mdi-plane-car", "", "200", True).SetItemColors("wifi1", "purple", vuetify.INTENSITY_DARKEN1, "", "")
	'
	VFlexDialog1.AddAvatarIcon(7, 1, "ano", "mdi-cards-heart", "48").SetItemColors("ano", "pink", vuetify.INTENSITY_DARKEN1, "", "")
	VFlexDialog1.AddAvatarText(7, 2, "ano1", "AM", "60").SetItemColors("ano1", "brown", vuetify.INTENSITY_DARKEN1, "white", "normal")
	
	'
	VFlexDialog1.Refresh
	'assign components to VField
	prjcomplete = VFlexDialog1.Get("prjcomplete")
	prjcomplete1 = VFlexDialog1.Get("prjcomplete1")
	chipQuantity = VFlexDialog1.Get("quantity")
	chpX = VFlexDialog1.Get("quantityx")
	chpavatar = VFlexDialog1.get("chpavatar")
	btnIcon = VFlexDialog1.Get("btnicon1")
	btnUpload = VFlexDialog1.Get("upload")
	btnIcon2 = VFlexDialog1.Get("btnIcon2")
	btnIcon3 = VFlexDialog1.Get("btnIcon3")
	btnImage1 = VFlexDialog1.Get("btnImage1")
	btnImage2 = VFlexDialog1.Get("btnImage2")
	icnWifi = VFlexDialog1.Get("wifi")
	icnWifi1 = VFlexDialog1.Get("wifi1")
	ano = VFlexDialog1.Get("ano")
	ano1 = VFlexDialog1.Get("ano1")
End Sub

private Sub btnIcon1_click (e As BANanoEvent)
	vuetify.ShowSnackBarSuccess("Done!")
End Sub

'show the file selector
Private Sub upload_Button_Click (e As BANanoEvent)
	'*** NB: also generate a file change event for this component
	page.refs = vuetify.GetRefs
	btnUpload.Click
End Sub

Sub upload_change(fileObj As Map)
	page.refs = vuetify.GetRefs
	'has the file been specified
	If banano.IsNull(fileObj) Or banano.IsUndefined(fileObj) Then Return
	'show the loading indicator
	btnUpload.UpdateLoading(page, True)
	'get file details
	Dim fileDet As FileObject
	fileDet = BANanoShared.GetFileDetails(fileObj)
	'get the file name
	Dim fn As String = fileDet.FileName
	'you can check the size here
	Dim fs As Long = fileDet.FileSize
	If fs >= 5000 Then
	End If
	'start uploading the file to assets folder
	fileDet = BANanoShared.UploadFileWait(fileObj)
	'get the status of the upload
	Dim sstatus As String = fileDet.Status
	Select Case sstatus
		Case "error"
			'hide the uploader
			btnUpload.UpdateLoading(page, False)
			vuetify.ShowSnackBarError($"The file '${fn}' was not uploaded successfully!"$)
		Case "success"
			vuetify.ShowSnackBarSuccess($"The file '${fn}' was uploaded successfully!"$)
	End Select
	'get the upload full path
	Dim fp As String = fileDet.FullPath
	'update state of some element like an image
	'for vfield use SetValue
	'vimage.SetValue(page, fp)
	'vimage.SetImage(page, fp)
	'hide the uploading status
	btnUpload.UpdateLoading(page, False)
	'clear the file input
	btnUpload.Clear
End Sub

Sub beforeEnter(boTo As Map, boFrom As Map, boNext As BANanoObject)   'ignoreDeadCode
	vuetify.Loading(True)
	'the page we are going to
	'vuetify.SaveRoute(boTo, False)
	'check authentication
	'If vuetify.Authenticated = False Then
	'user is not authenticated, go to login page
	'	vuetify.NavigateToNext(boNext, "login")
	'	Return
	'End If
	'continue navigation
	vuetify.NavigateToNext(boNext, "")
	'update the page title
	vuetify.SetBrowserTitle(boTo)
End Sub

'You are able to access reactive data and events that are active with the created hook.
'Templates and Virtual DOM have not yet been mounted or rendered:
'Sub created		'IgnoreDeadCode
'	Log("created")
'End Sub

'In the mounted hook, you will have full access to the reactive component, templates, and rendered DOM
Sub mounted		'ignoreDeadCode
	vuetify.Loading(False)
End Sub

'Use beforeDestroy if you need to clean-up events or reactive subscriptions:	
'Sub beforedestroy		'ignoreDeadCode
'	Log("beforedestroy")
'End Sub

'The updated hook runs after data changes on your component and the DOM re-renders.
'Sub updated			'ignoreDeadCode
'	Log("updated")
'End Sub

'The beforeUpdate hook runs after data changes on your component and the update cycle begins, right before the DOM is patched and re-rendered.
'Sub beforeupdate		'ignoreDeadCode
'	Log("beforeupdate")
'End Sub

'The beforeMount hook runs right before the initial render happens and after the template or render functions have been compiled:
'Sub beforemount		'ignoreDeadCode
'	Log("beforemount")
'End Sub

'The beforeCreate hook runs at the very initialization of your component. data has not been made reactive, and events have not been set up yet
'Sub beforecreate		'ignoreDeadCode
'	Log("beforecreate")
'End Sub

'Use destroyed if you need do any last-minute cleanup or inform a remote server that the component was destroyed:
'Sub destroyed		'ignoreDeadCode
'	Log("destroyed")
'End Sub

Private Sub VFlexDialog1_Yes_Click (e As BANanoEvent)
	VFlexDialog1.Hide
End Sub

Private Sub VFlexDialog1_No_Click (e As BANanoEvent)
	VFlexDialog1.Hide
End Sub

Private Sub VFlexDialog1_Cancel_Click (e As BANanoEvent)
	VFlexDialog1.Hide
End Sub

Private Sub btnShowDialog_Click (e As BANanoEvent)
	VFlexDialog1.Show
End Sub