﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.5
@EndOfDesignText@
#ignorewarnings:12
#Region BANano 
	' <-------------- IMPORTANT! This is because we want this module to be transpiled by BANano 
#End Region

'Static code module
Sub Class_Globals	
	Public vuetify As VuetifyApp
	Public page As VueComponent
	Public path As String
	Public name As String = "fe3"
	Private banano As BANano	'ignore
	Private btnShowDialog As VBtn
	Private VCol1 As VCol
	Private VContainer1 As VContainer
	Private VFlexDialog1 As VFlexDialog
	Private VFlexDialog1Form As VForm
	Private VRow1 As VRow
	Private test1 As VField
	Private test2 As VField
	Private currencies As VField
	Private countries As VField
	Private colors As VField
	'
	Private email As VField
	Private website As VField
	Private thousands As VField
	Private money As VField
	Private gender As VField
	Private phones As VField
	Private persons As VField
	Private ragc As VField
	Private rags As VField
	Private ragud As VField
	Private react As VField
End Sub

Sub Initialize(v As VuetifyApp)
	'establish a reference to the app
	vuetify = v
	'initialize the component
	page.Initialize(Me, name)
	page.vuetify = vuetify
	'set the page title
	page.Title = "Page"
	'uncomment this line if this will be the first page
	'page.StartPage
	path = page.path
	'
	'build the page html here
	banano.LoadLayout(page.Here, "fe3layout")
	VFlexDialog1Form = VFlexDialog1.form
	CreateVFlexDialog1
		
	'initialize this on pgIndex.AddPages
	'add the route page to vuetify instance
	vuetify.AddRoute(page)
End Sub

Sub CreateVFlexDialog1
	VFlexDialog1.Clear
	Dim options As Map = CreateMap()
	options.Put("a", "A")
	options.Put("b", "B")
	options.Put("c", "C")
	'
	Dim options1 As Map = CreateMap()
	options1.Put("a", "A")
	options1.Put("b", "B")
	options1.Put("c", "C")
	
	VFlexDialog1.AddComboBox(1, 1, "test1", "Combo", options, "a", False)
	'
	VFlexDialog1.AddSelect(1, 2, "test2", "Select", options1, "b", False)
	'
	VFlexDialog1.AddCountryList(2, 1, "countries", "Country List", "")
	'
	VFlexDialog1.AddCurrencyList(2, 2, "currencies", "Currency List", "")
	'
	Dim options2 As Map = CreateMap()
	options2.Put("red", "Behind Schedule")
	options2.Put("orange", "In Progress")
	options2.Put("green", "Ahead of Schedule")
	VFlexDialog1.AddCustomColors(3, 1, "colors", "Custom Colors", options2, "green")
	'
	VFlexDialog1.AddGenderList(3, 2, "gender", "Gender", "male")
	'
	VFlexDialog1.AddWebsite(4, 1, "website", "Website", "http://www.b4x.com")
	'
	VFlexDialog1.AddEmail(4, 2, "email", "Email", "b4j@b4x.com")
	'
	VFlexDialog1.AddMoney(5, 1, "money", "Money", "1,234.56")
	'
	VFlexDialog1.AddThousands(5, 2, "thousands", "Thousands", "123,345")
	'
	VFlexDialog1.AddPhonesList(6, 1, "phones", "Dialing Codes", "")
	'
	VFlexDialog1.AddPersonsList(6, 2, "persons", "Persons List", "")
	'
	VFlexDialog1.AddRAG_Circles(7, 1, "ragc", "RAG Circles", "")
	VFlexDialog1.AddRAG_Smiles(7, 2, "rags", "RAG Smile", "")
	VFlexDialog1.AddRAG_UpDown(7, 3, "ragud", "RAG Up/Down", "")
	VFlexDialog1.AddReactions(7, 4, "react", "Reactions", "")
	'
	VFlexDialog1.Refresh
	'
	colors = VFlexDialog1.Get("colors")
	test1 = VFlexDialog1.Get("test1")
	test2 = VFlexDialog1.Get("test2")
	countries = VFlexDialog1.Get("countries")
	currencies = VFlexDialog1.Get("currencies")
	website = VFlexDialog1.Get("website")
	email = VFlexDialog1.Get("email")
	money = VFlexDialog1.Get("money")
	thousands = VFlexDialog1.Get("thousands")
	gender = VFlexDialog1.Get("gender")
	phones = VFlexDialog1.Get("phones")
	persons = VFlexDialog1.Get("persons")
	'
	ragc = VFlexDialog1.Get("ragc")
	rags = VFlexDialog1.Get("rags")
	ragud = VFlexDialog1.Get("ragud")
	react = VFlexDialog1.Get("react")
End Sub	

Sub beforeEnter(boTo As Map, boFrom As Map, boNext As BANanoObject)   'ignoreDeadCode
	vuetify.Loading(True)
	'the page we are going to
	'vuetify.SaveRoute(boTo, False)
	'check authentication
	'If vuetify.Authenticated = False Then
	'user is not authenticated, go to login page
	'	vuetify.NavigateToNext(boNext, "login")
	'	Return
	'End If
	'continue navigation
	vuetify.NavigateToNext(boNext, "")
	'update the page title
	vuetify.SetBrowserTitle(boTo)
End Sub

'You are able to access reactive data and events that are active with the created hook.
'Templates and Virtual DOM have not yet been mounted or rendered:
'Sub created		'IgnoreDeadCode
'	Log("created")
'End Sub

'In the mounted hook, you will have full access to the reactive component, templates, and rendered DOM
Sub mounted		'ignoreDeadCode
	persons.ClearItems(page)
	persons.AddPerson(page, "anele", "Anele Mbanga", "./assets/myself.jpg")
	persons.AddPerson(page, "person1", "Person 1", "./assets/img5.png")
	persons.AddPerson(page, "person2", "Person 2", "./assets/img8.png")
	'
	vuetify.Loading(False)
End Sub

'Use beforeDestroy if you need to clean-up events or reactive subscriptions:	
'Sub beforedestroy		'ignoreDeadCode
'	Log("beforedestroy")
'End Sub

'The updated hook runs after data changes on your component and the DOM re-renders.
'Sub updated			'ignoreDeadCode
'	Log("updated")
'End Sub

'The beforeUpdate hook runs after data changes on your component and the update cycle begins, right before the DOM is patched and re-rendered.
'Sub beforeupdate		'ignoreDeadCode
'	Log("beforeupdate")
'End Sub

'The beforeMount hook runs right before the initial render happens and after the template or render functions have been compiled:
'Sub beforemount		'ignoreDeadCode
'	Log("beforemount")
'End Sub

'The beforeCreate hook runs at the very initialization of your component. data has not been made reactive, and events have not been set up yet
'Sub beforecreate		'ignoreDeadCode
'	Log("beforecreate")
'End Sub

'Use destroyed if you need do any last-minute cleanup or inform a remote server that the component was destroyed:
'Sub destroyed		'ignoreDeadCode
'	Log("destroyed")
'End Sub

Private Sub VFlexDialog1_No_Click (e As BANanoEvent)
	VFlexDialog1.hide
End Sub

Private Sub VFlexDialog1_Cancel_Click (e As BANanoEvent)
	VFlexDialog1.Hide
End Sub

Private Sub btnShowDialog_Click (e As BANanoEvent)
	VFlexDialog1.Show
End Sub