﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.07
@EndOfDesignText@
'Static code module
Sub Class_Globals
	'the vuetify instance	
	Public vuetify As VuetifyApp
	'this route page
	Public page As VueComponent
	'the path to this page
	Public path As String
	'the name of the page, should be unique
	Public name As String = "home"
	'banano transpiler
	Private banano As BANano			'ignore
	Private VContainer1 As VContainer	'ignore
		
	'COMPULSORY
	Private VFlexDialog1Form As VForm
	Private btnShowDialog As VBtn
	Private VCol1 As VCol
	Private VRow1 As VRow
	'COMPULSORY
	Private txtfirstname As VField     'ignore
	Private txtlastname As VField     'ignore
	Private txtbio As VField     'ignore
	Private cbolang As VField     'ignore
	Private colhair As VField     'ignore
	Private dpdob As VField     'ignore
	Private txtheight As VField     'ignore
	Private filimage As VField     'ignore
	Private imgprofile As VField     'ignore
	Private radgender As VField     'ignore
	Private rngsalary As VField     'ignore
	Private ratservice As VField     'ignore
	Private sldloan As VField     'ignore
	Private teltel As VField     'ignore
	Private timmeet As VField     'ignore
	Private pwdpass As VField     'ignore
	Private swtactive As VField     'ignore
	Private chkagree As VField     'ignore
	
	
	Private VFlexDialog1 As VFlexDialog
End Sub

'initializes the page and builds the html structure
Sub Initialize(v As VuetifyApp)						'ignoreDeadCode
	'establish a reference to the app
	vuetify = v
	'initialize the page using unique name
	page.Initialize(Me, name)
	'link the vuetify instance
	page.vuetify = vuetify
	'set the page title
	page.Title = "Home"
	'make this the start page
	page.StartPage
	path = page.path
	'
	'build the page html here
	banano.LoadLayout(page.Here, "homelayout")
	'IMPORTANT
	VFlexDialog1Form = VFlexDialog1.form
	'
	BuildPreferences
	'
	'add this route component to the app
	vuetify.AddRoute(page)
End Sub

Sub BuildPreferences
	VFlexDialog1.Clear
	'create options
	Dim options As Map = CreateMap()
	options.Put("eng", "English")
	options.Put("afr", "Afrikaans")
	options.Put("xho", "Xhosa")
	options.Put("nde", "isiNdebele")
	options.Put("zul", "isiZulu")
	options.Put("sep", "Sepedi")
	options.Put("ses", "Sesotho")
	options.Put("tsw", "Setswana")
	options.Put("swa", "seSwati")
	options.Put("tsh", "Tshivenda")
	options.Put("xit", "Xitsonga")
	
	'ROW 1
	VFlexDialog1.AddTextField(1, 1, "firstname", "First Name","Anele")
	VFlexDialog1.AddTextField(1, 2, "lastname", "First Name","Mbanga")
	'ROW 2
	VFlexDialog1.AddTextArea(2, 1, "bio", "Biography","")
	'ROW 3
	VFlexDialog1.AddAutoComplete(3, 1, "lang", "Language", options, "eng", True)
	VFlexDialog1.AddColor(3, 2, "hair", "Enter hair color","black")
	'ROW 4
	VFlexDialog1.AddDate(4, 1, "dob", "Enter Date of Birth","1973-04-15")
	VFlexDialog1.AddDouble(4, 2, "height", "Enter your height","1.85")
	'ROW 5
	VFlexDialog1.AddFileInput(5, 1,"image", "Please upload your image")
	VFlexDialog1.AddImage(5, 2, "profile", "./assets/myself.jpg", "100", "100")
	'
	Dim gender As Map = CreateMap()
	gender.Put("male", "Male")
	gender.Put("female", "Female")
	gender.Put("other", "Other")
	'ROW 6
	VFlexDialog1.AddRadioGroup(6, 1, "gender", "Gender", gender,"male", True)
	VFlexDialog1.AddRange(6, 2, "salary", "Salary Range", 5000, 10000, 100, 6000)
	
	'ROW 7
	VFlexDialog1.AddRating(7, 1, "service", 5, "How can you rate our service?", 2)
	VFlexDialog1.AddSlider(7, 2, "loan", "Loan amount", 1000, 5000, 50, 1500)
	
	'ROW 8
	VFlexDialog1.AddTelephone(8, 1, "tel", "Telephone", "")
	VFlexDialog1.AddTime(8, 2, "meet", "Time of Meeting","09:00")
	
	'ROW 9
	VFlexDialog1.AddPassword(9, 1, "pass", "Enter your password","", True)
	
	'ROW 10
	VFlexDialog1.AddSwitch(10, 1, "active","Active", True, True)
	VFlexDialog1.AddCheckBox(10, 2, "agree", "I agree with Terms & Conditions",True)
	'
	VFlexDialog1.Refresh 
	'get the vFields for bindings
	'COMPULSORY
	txtfirstname = VFlexDialog1.Get("firstname")
	txtlastname = VFlexDialog1.Get("lastname")
	txtbio = VFlexDialog1.Get("bio")
	cbolang = VFlexDialog1.Get("lang")
	colhair = VFlexDialog1.Get("hair")
	dpdob = VFlexDialog1.Get("dob")
	txtheight = VFlexDialog1.Get("height")
	filimage = VFlexDialog1.Get("image")
	imgprofile = VFlexDialog1.Get("profile")
	radgender = VFlexDialog1.Get("gender")
	rngsalary = VFlexDialog1.Get("salary")
	ratservice = VFlexDialog1.Get("service")
	sldloan = VFlexDialog1.Get("loan")
	teltel = VFlexDialog1.Get("tel")
	timmeet = VFlexDialog1.Get("meet")
	pwdpass = VFlexDialog1.Get("pass")
	swtactive = VFlexDialog1.Get("active")
	chkagree = VFlexDialog1.Get("agree")
	'Log(VFlexDialog1.Declarations)
	'Log(VFlexDialog1.Gets)
End Sub

Sub beforeEnter(boTo As Map, boFrom As Map, boNext As BANanoObject)   'ignoreDeadCode
	vuetify.Loading(True)
	'the page we are going to
	'vuetify.SaveRoute(boTo, False)
	'check authentication
	'If vuetify.Authenticated = False Then
	'user is not authenticated, go to login page
	'	vuetify.NavigateToNext(boNext, "login")
	'	Return
	'End If
	'continue navigation
	vuetify.NavigateToNext(boNext, "")
	'update the page title
	vuetify.SetBrowserTitle(boTo)
End Sub


'Use beforeDestroy if you need to clean-up events or reactive subscriptions:	
'Sub beforedestroy		'ignoreDeadCode
'	Log("beforedestroy")
'End Sub

'The updated hook runs after data changes on your component and the DOM re-renders.
'Sub updated			'ignoreDeadCode
'	Log("updated")
'End Sub

'The beforeUpdate hook runs after data changes on your component and the update cycle begins, right before the DOM is patched and re-rendered.
'Sub beforeupdate		'ignoreDeadCode
'	Log("beforeupdate")
'End Sub

'The beforeMount hook runs right before the initial render happens and after the template or render functions have been compiled:
'Sub beforemount		'ignoreDeadCode
'	Log("beforemount")
'End Sub

'The beforeCreate hook runs at the very initialization of your component. data has not been made reactive, and events have not been set up yet
'Sub beforecreate		'ignoreDeadCode
'	Log("beforecreate")
'End Sub

'You are able to access reactive data and events that are active with the created hook.
'Templates and Virtual DOM have not yet been mounted or rendered:
'Sub created		'IgnoreDeadCode
'	Log("created")
'End Sub

'In the mounted hook, you will have full access to the reactive component, templates, and rendered DOM
Sub mounted		'ignoreDeadCode
	vuetify.Loading(False)
End Sub

'Use destroyed if you need do any last-minute cleanup or inform a remote server that the component was destroyed:
'Sub destroyed		'ignoreDeadCode
'	Log("destroyed")
'End Sub

Private Sub VFlexDialog1_Yes_Click (e As BANanoEvent)
	Dim data As Map = VFlexDialog1.GetData
	Log(data)
End Sub

Private Sub VFlexDialog1_No_Click (e As BANanoEvent)
	VFlexDialog1.Hide
End Sub

Private Sub VFlexDialog1_Cancel_Click (e As BANanoEvent)
	VFlexDialog1.Hide
End Sub

Private Sub btnShowDialog_Click (e As BANanoEvent)
	'shows the dialog and set defaults
	VFlexDialog1.Show
	'change a value
	'txtfirstname.Text = "Xolani"
End Sub

Private Sub image_Change(fileObj As Map)
	page.refs = vuetify.GetRefs
	'has the file been specified
	If banano.IsNull(fileObj) Or banano.IsUndefined(fileObj) Then Return
	'show the loading indicator
	filimage.UpdateLoading(page, True)
	'get file details
	Dim fileDet As FileObject
	fileDet = BANanoShared.GetFileDetails(fileObj)
	'get the file name
	Dim fn As String = fileDet.FileName
	'you can check the size here
	Dim fs As Long = fileDet.FileSize
	If fs >= 5000 Then
	End If
	'start uploading the file to assets folder
	fileDet = BANanoShared.UploadFileWait(fileObj)
	'get the status of the upload
	Dim sstatus As String = fileDet.Status
	Select Case sstatus
		Case "error"
			'hide the uploader
			filimage.UpdateLoading(page, False)
			vuetify.ShowSnackBarError($"The file '${fn}' was not uploaded successfully!"$)
		Case "success"
			vuetify.ShowSnackBarSuccess($"The file '${fn}' was uploaded successfully!"$)
	End Select
	'get the upload full path
	Dim fp As String = fileDet.FullPath
	'update state of some element like an image
	imgprofile.SetValue(page, fp)
	'hide the uploading status
	filimage.UpdateLoading(page, False)
End Sub

'on the password we have showeyes, to toggle it, we need click append
Private Sub pass_ClickAppend (e As BANanoEvent)
	pwdpass.TogglePassword
End Sub