﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.5
@EndOfDesignText@
#ignorewarnings:12
#Region BANano 
	' <-------------- IMPORTANT! This is because we want this module to be transpiled by BANano 
#End Region

'Static code module
Sub Class_Globals	
	Public vuetify As VuetifyApp
	Public page As VueComponent
	Public path As String
	Public name As String = "flexd2"
	Private banano As BANano	'ignore
	Private btnShowDialog As VBtn
	Private VCol1 As VCol
	Private VContainer1 As VContainer
	Private VFlexDialog1 As VFlexDialog
	Private VRow1 As VRow
	
	'will be used by bind-state
	Private VFlexDialog1Form As VForm
	Private imgMyself As VField
	Private btnSend As VField
	Private p1 As VField
	Private p2 As VField
	Private p3 As VField
	Private btnChange As VField
	Private txtPrefix As VField
	Private txtSuffix As VField
	Private h1 As VField
	Private h2 As VField
	Private h3 As VField
	Private h4 As VField
	Private h5 As VField
	Private h6 As VField
	
End Sub

Sub Initialize(v As VuetifyApp)
	'establish a reference to the app
	vuetify = v
	'initialize the component
	page.Initialize(Me, name)
	page.vuetify = vuetify
	'set the page title
	page.Title = "Page"
	'uncomment this line if this will be the first page
	'page.StartPage
	path = page.path
	'
	'build the page html here
	banano.LoadLayout(page.Here, "flexd2layout")
	'get the form
	VFlexDialog1Form = VFlexDialog1.Form
	'
	BuildFlexDialog
		
	'initialize this on pgIndex.AddPages
	'add the route page to vuetify instance
	vuetify.AddRoute(page)
End Sub

Sub BuildFlexDialog
	VFlexDialog1.Clear
	'add an avatar
	VFlexDialog1.AddAvatar(1, 1, "myself", "./assets/myself.jpg", "100")
	'center the avatar on the RC
	VFlexDialog1.SetItemCenterOnParent("myself", True)
	'add a button
	VFlexDialog1.AddButton(1, 2, "btnSend", "Send Email", True, False, True, True)
	'set the colors
	VFlexDialog1.SetItemColors("btnsend", vuetify.COLOR_BLUE, vuetify.INTENSITY_NORMAL, vuetify.COLOR_WHITE, vuetify.INTENSITY_NORMAL)
	'
	VFlexDialog1.AddLabel(2, 1, "p1", vuetify.size_p, "This is my first paragraph.", True, False)
	VFlexDialog1.AddLabel(3, 1, "p2", vuetify.size_p, "This is my first dynamic paragraph.", False, False)
	VFlexDialog1.AddButton(3, 2, "btnChange", "Change Paragraph", False, True, False, False)
	VFlexDialog1.AddLabel(4, 1, "p3", vuetify.size_p, "", True, True)
	'
	VFlexDialog1.AddTextField(5, 1, "prefix", "Has Prefix", "20.00").SetItemPrefix("prefix", "$")
	VFlexDialog1.AddTextField(5, 2, "suffix", "Has Suffix", "100").SetItemSuffix("suffix", "km")
	'
	VFlexDialog1.AddLabel(6, 1, "h1", vuetify.size_h1, "This is H1 heading", True, False)
	VFlexDialog1.AddLabel(7, 1, "h2", vuetify.size_h2, "This is H2 heading", True, False)
	VFlexDialog1.AddLabel(8, 1, "h3", vuetify.size_h3, "This is H3 heading", True, False)
	VFlexDialog1.AddLabel(9, 1, "h4", vuetify.size_h4, "This is H4 heading", True, False)
	VFlexDialog1.AddLabel(10, 1, "h5", vuetify.size_h5, "This is H5 heading", True, False)
	VFlexDialog1.AddLabel(11, 1, "h6", vuetify.size_h6, "This is H6 heading", True, False)
	VFlexDialog1.AddLabel(12, 1, "div", vuetify.size_div, "This is a DIV", True, False)
	VFlexDialog1.AddLabel(13, 1, "span", vuetify.size_span, "This is a SPAN", True, False)
	'
	VFlexDialog1.Refresh
	'
	imgMyself = VFlexDialog1.Get("myself")
	btnSend = VFlexDialog1.Get("btnsend")
	btnChange = VFlexDialog1.Get("btnChange")
	p1 = VFlexDialog1.Get("p1")
	p2 = VFlexDialog1.Get("p2")
	p3 = VFlexDialog1.Get("p3")
	txtPrefix = VFlexDialog1.Get("prefix")
	txtSuffix = VFlexDialog1.Get("suffix")
	'
	h1 = VFlexDialog1.Get("h1")
	h2 = VFlexDialog1.Get("h2")
	h3 = VFlexDialog1.Get("h3")
	h4 = VFlexDialog1.Get("h4")
	h5 = VFlexDialog1.Get("h5")
	h6 = VFlexDialog1.Get("h6")
	
	'
End Sub

Sub btnChange_click(e As BANanoEvent)
	p2.CaptionRT = BANanoShared.LoremIpsum(1)
End Sub

Sub btnSend_click(e As BANanoEvent)
	vuetify.ShowSwalInfo("Send an email...")
End Sub


Sub beforeEnter(boTo As Map, boFrom As Map, boNext As BANanoObject)   'ignoreDeadCode
	vuetify.Loading(True)
	'the page we are going to
	'vuetify.SaveRoute(boTo, False)
	'check authentication
	'If vuetify.Authenticated = False Then
	'user is not authenticated, go to login page
	'	vuetify.NavigateToNext(boNext, "login")
	'	Return
	'End If
	'continue navigation
	vuetify.NavigateToNext(boNext, "")
	'update the page title
	vuetify.SetBrowserTitle(boTo)
End Sub

'You are able to access reactive data and events that are active with the created hook.
'Templates and Virtual DOM have not yet been mounted or rendered:
'Sub created		'IgnoreDeadCode
'	Log("created")
'End Sub

'In the mounted hook, you will have full access to the reactive component, templates, and rendered DOM
Sub mounted		'ignoreDeadCode
	vuetify.Loading(False)
End Sub

'Use beforeDestroy if you need to clean-up events or reactive subscriptions:	
'Sub beforedestroy		'ignoreDeadCode
'	Log("beforedestroy")
'End Sub

'The updated hook runs after data changes on your component and the DOM re-renders.
'Sub updated			'ignoreDeadCode
'	Log("updated")
'End Sub

'The beforeUpdate hook runs after data changes on your component and the update cycle begins, right before the DOM is patched and re-rendered.
'Sub beforeupdate		'ignoreDeadCode
'	Log("beforeupdate")
'End Sub

'The beforeMount hook runs right before the initial render happens and after the template or render functions have been compiled:
'Sub beforemount		'ignoreDeadCode
'	Log("beforemount")
'End Sub

'The beforeCreate hook runs at the very initialization of your component. data has not been made reactive, and events have not been set up yet
'Sub beforecreate		'ignoreDeadCode
'	Log("beforecreate")
'End Sub

'Use destroyed if you need do any last-minute cleanup or inform a remote server that the component was destroyed:
'Sub destroyed		'ignoreDeadCode
'	Log("destroyed")
'End Sub

Private Sub VFlexDialog1_Yes_Click (e As BANanoEvent)
	VFlexDialog1.Hide
End Sub

Private Sub VFlexDialog1_No_Click (e As BANanoEvent)
	VFlexDialog1.Hide
End Sub

Private Sub VFlexDialog1_Cancel_Click (e As BANanoEvent)
	VFlexDialog1.Hide
End Sub

Private Sub btnShowDialog_Click (e As BANanoEvent)
	VFlexDialog1.Show
End Sub